/******************************************************************************
CLASSE ABIBLIA
CRIADO: 09-2007
ALTERADO: 16-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "abiblia.h"

//Exceo: chamada a uma Classe Main
#include "readbiblia.h"
#include "readpesquisa.h"
#include "readpassagens.h"
#include "readestudos.h"
#include "frmbiblia.h"
#include "frmpesquisa.h"
#include "frmpassagens.h"
#include "frmestudos.h"
#include "dialanotacoes.h"
#include "dialconfiguracoes.h"
#include "dialresolucao.h"
#include "dialsobre.h"
#include "exportar.h"
#include "promessas.h"
#include "amessagebox.h"
#include "atabwidget.h"


abiblia::abiblia():QMainWindow(){
	QDir dir;
	//criando pastas do usurio
	if (!dir.exists(DIR_PATH))
		dir.mkpath(DIR_PATH);
	//Recuperando anotaes de verses anteriores
	if (dir.exists(DIR_RODAPE)){
		if (!dir.exists(DIR_RODAPECHECKED)){
			Exportar exp;
			exp.recuperarAnotacoes();
		}
		else
			dir.rmpath(DIR_RODAPECHECKED);
	}
	//Gerando arquivo de configurao de texto
	config.setArqConfig();

	resolucao.lerResolucao();
	unsigned short int FONTE_MEDIA = resolucao.getFonteMedia();
	
	setMinimumSize( QSize( 700, 660 ) );
	carregarResolucao();
	setWindowTitle("aBblia Software");
	icon.load((const QString&)DIR_ICONS + "icon.png");
	setWindowIcon(icon);

	QFont fonte = QFont("Bitstream", FONTE_MEDIA);
	
	//Abas
	aTabWidget = new ATabWidget( this );
	aTabWidget->setFont(fonte);
	
	//Layout Superior
	gbox = new QGridLayout;
	Promessas* p = new Promessas();
        QToolButton* btnIconGrande = new QToolButton(this);
	icon.load((const QString&)DIR_ICONS + "iconMaior.png");
        btnIconGrande->setIcon(icon);
        btnIconGrande->setAutoRaise(true);
        btnIconGrande->setToolButtonStyle(Qt::ToolButtonIconOnly);
        btnIconGrande->setIconSize(icon.size());
        btnIconGrande->setToolTip("Gerar nova promessa");
        gbox->addWidget(btnIconGrande, 0, 0);
	gbox->addWidget(p->getPromessa(), 0, 1);
	gbox->setColumnStretch ( 1, 1 );
	gbxBox = new QGroupBox(this);
	gbxBox->setLayout(gbox);
	gbxBox->setForegroundRole ( QPalette::BrightText );
	delete p;
        QObject::connect(btnIconGrande,SIGNAL(pressed() ),this,SLOT(chamarNovaPromessa() ) );
	
	carregarSplash();
	
	//Menus
	actListarAnotacoes = new QAction(tr("Listar anotaes"), this);
	actListarAnotacoes->setStatusTip(tr("Lista as anotaes do usurio"));
	QObject::connect(actListarAnotacoes, SIGNAL(triggered() ), this, SLOT(chamarAbrirAnot() ) );
	
	actFecharTodasAbas = new QAction(tr("Fechar todas as abas"), this);
	actFecharTodasAbas->setStatusTip(tr("Fecha todas as abas abertas"));
	QObject::connect(actFecharTodasAbas, SIGNAL(triggered() ), this, SLOT(slotFecharTodasAbas() ) );

	actSair = new QAction(tr("Sair"), this);
	actSair->setShortcut(tr("Alt+F4"));
	actSair->setStatusTip(tr("Fechar esta janela"));
	icon.load((const QString&)DIR_ICONS + "exit.png");
	actSair->setIcon(icon);
	QObject::connect(actSair,SIGNAL(triggered() ),this,SLOT(close() ) );

	actChamarFrmBiblia = new QAction(tr("Bblia Sagrada"), this);
	actChamarFrmBiblia->setShortcut(tr("Ctrl+B"));
	//icon.load((const QString&)DIR_ICONS + "properties.png");
	//actChamarFormBiblia->setIcon(icon);
	QObject::connect(actChamarFrmBiblia,SIGNAL(triggered() ),this,SLOT(chamarFrmBiblia() ) );

	actChamarFrmPesquisa = new QAction(tr("Pesquisar"), this);
	actChamarFrmPesquisa->setShortcut(tr("Ctrl+F"));
	//icon.load((const QString&)DIR_ICONS + "properties.png");
	//actChamarFormBiblia->setIcon(icon);
	QObject::connect(actChamarFrmPesquisa,SIGNAL(triggered() ),this,SLOT(chamarFrmPesquisa() ) );

	actChamarFrmPassagens = new QAction(tr("Passagens"), this);
	actChamarFrmPassagens->setShortcut(tr("Ctrl+G"));
	//icon.load((const QString&)DIR_ICONS + "properties.png");
	//actChamarFormBiblia->setIcon(icon);
	QObject::connect(actChamarFrmPassagens,SIGNAL(triggered() ),this,SLOT(chamarFrmPassagens() ) );

	actChamarFrmEstudos = new QAction(tr("Estudos"), this);
	actChamarFrmEstudos->setShortcut(tr("Ctrl+E"));
	//icon.load((const QString&)DIR_ICONS + "properties.png");
	//actChamarFormBiblia->setIcon(icon);
	QObject::connect(actChamarFrmEstudos,SIGNAL(triggered() ),this,SLOT(chamarFrmEstudos() ) );

	actNovaPromessa = new QAction(tr("Nova promessa"), this);
	actNovaPromessa->setShortcut(tr("Ctrl+O"));
	//icon.load((const QString&)DIR_ICONS + "properties.png");
	//actChamarFormBiblia->setIcon(icon);
	QObject::connect(actNovaPromessa,SIGNAL(triggered() ),this,SLOT(chamarNovaPromessa() ) );

	actConfiguracoes = new QAction(tr("Configuraes"), this);
	actConfiguracoes->setStatusTip(tr("Configura opes de texto"));
	icon.load((const QString&)DIR_ICONS + "properties.png");
	actConfiguracoes->setIcon(icon);
	QObject::connect(actConfiguracoes,SIGNAL(triggered() ),this,SLOT(chamarConfigurarTextos() ) );

	#if defined(__linux__)
		actMudarResolucao = new QAction(tr("Mudar resoluo"), this);
		actMudarResolucao->setStatusTip(tr("Muda a Resoluo das fontes"));
		QObject::connect(actMudarResolucao,SIGNAL(triggered() ),this,SLOT(chamarMudarResolucao() ) );
	#endif

	actVerificarAtualizacoes = new QAction(tr("Verificar atualizaes"), this);
	actVerificarAtualizacoes->setStatusTip(tr("Verificar se existem atualizaes disponveis para downloads"));
	icon.load((const QString&)DIR_ICONS + "download.png");
	actVerificarAtualizacoes->setIcon(icon);
	QObject::connect(actVerificarAtualizacoes,SIGNAL(triggered() ),this,SLOT(chamarAtualizador() ) );

	actSobreaBiblia = new QAction(tr("Sobre a aBblia Software"), this);
	icon.load((const QString&)DIR_ICONS + "help.png");
	actSobreaBiblia->setIcon(icon);
	QObject::connect(actSobreaBiblia,SIGNAL(triggered() ),this,SLOT(chamarSobre() ) );
	
	actSobreQt = new QAction(tr("Sobre o Qt"), this);
	//icon.load((const QString&)DIR_ICONS + "help.png");
	//actSobreQt->setIcon(icon);
	QObject::connect(actSobreQt,SIGNAL(triggered() ),this,SLOT(chamarSobreQt() ) );

	mnuAplicacao = new QMenu();
	mnuAplicacao = menuBar()->addMenu(tr("A&plicao"));
	mnuAplicacao->addAction(actChamarFrmBiblia);
	mnuAplicacao->addAction(actChamarFrmPesquisa);
	mnuAplicacao->addAction(actChamarFrmPassagens);
	mnuAplicacao->addAction(actChamarFrmEstudos);
	mnuAplicacao->addSeparator();
	mnuAplicacao->addAction(actListarAnotacoes);
	mnuAplicacao->addSeparator();
	mnuAplicacao->addAction(actNovaPromessa);
	mnuAplicacao->addSeparator();
	mnuAplicacao->addAction(actFecharTodasAbas);
	mnuAplicacao->addSeparator();
	mnuAplicacao->addAction(actSair);

	mnuOpcoes = new QMenu();
	mnuOpcoes = menuBar()->addMenu(tr("&Opes"));
	mnuOpcoes->addAction(actConfiguracoes);
	#if defined(__linux__)
		mnuOpcoes->addAction(actMudarResolucao);
	#endif
	mnuOpcoes->addAction(actVerificarAtualizacoes);

	mnuAjuda = new QMenu();
	mnuAjuda = menuBar()->addMenu(tr("A&juda"));
	mnuAjuda->addAction(actSobreaBiblia);
	mnuAjuda->addAction(actSobreQt);
}
/****************************************************************************************************************************
SLOTS E MTODOS FUNCIONAIS
****************************************************************************************************************************/
//Menus
void abiblia::chamarSobreQt(){
	QMessageBox::aboutQt(this);
}
void abiblia::chamarSobre(){
	DialSobre *mywidget = new DialSobre();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
}
void abiblia::chamarAbrirAnot(){
	DialAnotacoes *mywidget = new DialAnotacoes();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
	QObject::connect(mywidget,SIGNAL(novaJanela(ReadBiblia*) ),this,SLOT(slotGerarAbas(ReadBiblia*) ) );
}
void abiblia::chamarAtualizador(){
	QString versao = VERSAO;
	QString so = SO;
	QString arc = ARQUITETURA;
	QString link = LINK_UPDATE;
	for (unsigned short int i = 0; i < versao.length(); i++)
		if (versao[i] == ' ')
			versao[i] = '_';
	link += "?so=" + so + "&arquitetura=" + arc + "&versao=" + versao;
	QUrl url(link);
	QDesktopServices::openUrl(url);
}
void abiblia::chamarMudarResolucao(){
	DialResolucao *mywidget = new DialResolucao();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
}
void abiblia::chamarConfigurarTextos(){
        DialConfiguracoes *mywidget = new DialConfiguracoes();
        mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
}
void abiblia::chamarFrmBiblia(){
	FrmBiblia *mywidget = new FrmBiblia();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
	QObject::connect(mywidget,SIGNAL(novaJanela(ReadBiblia*) ),this,SLOT(slotGerarAbas(ReadBiblia*) ) );
}
void abiblia::chamarFrmPesquisa(){
	FrmPesquisa *mywidget = new FrmPesquisa();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
	QObject::connect(mywidget,SIGNAL(novaJanela(ReadPesquisa*) ),this,SLOT(slotGerarAbas(ReadPesquisa*) ) );
}
void abiblia::chamarFrmPassagens(){
	FrmPassagens *mywidget = new FrmPassagens();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
	QObject::connect(mywidget,SIGNAL(novaJanela(ReadPassagens*) ),this,SLOT(slotGerarAbas(ReadPassagens*) ) );
}
void abiblia::chamarFrmEstudos(){
	FrmEstudos *mywidget = new FrmEstudos();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
	QObject::connect(mywidget,SIGNAL(novaJanela(ReadEstudos*) ),this,SLOT(slotGerarAbas(ReadEstudos*) ) );
	QObject::connect(mywidget,SIGNAL(fecharEstudos(const QString &, const QString &) ),this,
		SLOT(slotFecharEstudos(const QString &, const QString &) ) );
}
void abiblia::chamarNovaPromessa(){
	unsigned short int extraWidth = width() - minimumWidth();
	
	Promessas* p = new Promessas();
        QToolButton* btnIconGrande = new QToolButton(this);
        icon.load((const QString&)DIR_ICONS + "iconMaior.png");
        btnIconGrande->setIcon(icon);
        btnIconGrande->setAutoRaise(true);
        btnIconGrande->setToolButtonStyle(Qt::ToolButtonIconOnly);
        btnIconGrande->setIconSize(icon.size());
        btnIconGrande->setToolTip("Gerar nova promessa");
	delete gbox;
	gbox = new QGridLayout;
        gbox->addWidget(btnIconGrande, 0, 0);
	gbox->addWidget(p->getPromessa(), 0, 1);
	gbox->setColumnStretch ( 1, 1 );
	delete gbxBox;
	gbxBox = new QGroupBox(this);
	gbxBox->setLayout(gbox);
	#if defined(__linux__)
		gbxBox->setGeometry(QRect( 10, 35, 681 + extraWidth, 90));
	#elif defined(_WIN32) || defined(__WIN32) || defined(WIN32) || defined(__WIN32__)
		gbxBox->setGeometry(QRect( 10, 25, 681 + extraWidth, 85));
	#endif
	gbxBox->show();
	delete p;
        QObject::connect(btnIconGrande,SIGNAL(pressed() ),this,SLOT(chamarNovaPromessa() ) );
}

//Abertura
void abiblia::carregarSplash(){
	unsigned short int FONTE_MEDIA = resolucao.getFonteMedia();
	QFont fonte = QFont("Bitstream", FONTE_MEDIA);
	
	//Mostrar Splash
	splash = new QSplashScreen(QPixmap((const QString&)DIR_IMAGES + "splash.png"));
	splash->setFont( fonte );
	splash->show();
	splash->showMessage("Bem vindo  aBblia Software!\nIniciando aplicao...\n", Qt::AlignCenter | Qt::AlignBottom,  Qt::white);
	mutex.lock();
	waitC.wait(&mutex, 1000);
	mutex.unlock();
	qApp->processEvents();
	
	BancoUser bancoUser;
	//Se existem Abas a serem recuperadas
	if (bancoUser.maxEstadoAbas()){
		//Recupera estado das Abas
		recuperarEstadoAbas();
		
		splash->showMessage("Bem vindo  aBblia Software!\nAbas carregadas com sucesso!\n", Qt::AlignCenter | Qt::AlignBottom,  Qt::white);
		mutex.lock();
		waitC.wait(&mutex, 700);
		mutex.unlock();
	}
	else{
		splash->showMessage("Bem vindo  aBblia Software!\nNenhuma Aba a ser carregada!\n", Qt::AlignCenter | Qt::AlignBottom,  Qt::white);
		mutex.lock();
		waitC.wait(&mutex, 700);
		mutex.unlock();
	}
	
	splash->showMessage("Bem vindo  aBblia Software!\nBoa leitura!\n", Qt::AlignCenter | Qt::AlignBottom,  Qt::white);
	mutex.lock();
	waitC.wait(&mutex, 2000);
	mutex.unlock();
	qApp->processEvents();
	
	//Finaliza e apaga o Splash
	splash->finish(this);
	delete splash;
	splash = 0;
}

//Abas
void abiblia::slotGerarAbas(ReadBiblia* read){
	aTabWidget->gerarAbas(read);
}
void abiblia::slotGerarAbas(ReadEstudos* read){
	aTabWidget->gerarAbas(read);
}
void abiblia::slotGerarAbas(ReadPesquisa* read){
	aTabWidget->gerarAbas(read);
}
void abiblia::slotGerarAbas(ReadPassagens* read){
	aTabWidget->gerarAbas(read);
}
void abiblia::slotFecharEstudos(const QString &strCategoria, const QString &strTitulo){
	BancoUser bancoUser;
	int cont = 0;

	if (!strCategoria.isEmpty()){
		while (cont <= aTabWidget->count()){
			if (ReadEstudos* read = qobject_cast<ReadEstudos*>(aTabWidget->widget(cont)) ){
				if ( (strCategoria == read->getCategoria()) && (strTitulo == read->getTitulo()) ){
					aTabWidget->fecharAba(cont);
					cont = -1;
				}
			}
			cont++;
		}
	}
	else{
		while (cont <= aTabWidget->count()){
			if (qobject_cast<ReadEstudos*>(aTabWidget->widget(cont)) ){
				aTabWidget->fecharAba(cont);
				cont = -1;
			}
			cont++;
		}
	}
}
void abiblia::slotFecharTodasAbas(){
	bool salvo = true;
	bool flag = false;
	int cont = 0;
	
	while (aTabWidget->widget(cont) != 0){
		if (ReadBiblia* read = qobject_cast<ReadBiblia*>(aTabWidget->widget(cont)) )
			if (read->getSalvo() == false)
				salvo = false;
				
		if (ReadEstudos* read = qobject_cast<ReadEstudos*>(aTabWidget->widget(cont)) ){
			if (read->getSalvo() == false)
				salvo = false;
		}
		cont++;
	}

	if (!salvo){
		AMessageBox aMsgBox;
		flag = aMsgBox.yesNo("Existem abas com contedos que no foram salvos.\nDeseja fecha-las e perder seus contedos?", "Fechar abas");
	}
	if (salvo || flag){
		aTabWidget->fecharTodasAbas();
	}
}
void abiblia::recuperarEstadoAbas(){
	BancoUser bancoUser;
	QStringList list;
	QVariant n1, n2;
	int cont, maxId;
	
	maxId = bancoUser.maxEstadoAbas();
	
	for (cont = 0; cont <= maxId; cont++){
		list = bancoUser.getEstadoAbas(cont);
		n1.setValue(list.value(4));
		n2.setValue(list.value(5));
	
		if (list.value(0) == "ReadBiblia"){
			ReadBiblia *read = new ReadBiblia(list.value(1), n1.toInt());
			read->setParent(this, Qt::Window);
			slotGerarAbas(read);
		}
		else if (list.value(0) == "ReadPesquisa"){
			ReadPesquisa *mywidget = new ReadPesquisa(list.value(1), n1.toInt(), n2.toInt());
			mywidget->setParent(this, Qt::Window);
			slotGerarAbas(mywidget);
		}
		else if (list.value(0) == "ReadPassagens"){
			ReadPassagens *mywidget = new ReadPassagens(list.value(1), n1.toInt(), list.value(2));
			mywidget->setParent(this, Qt::Window);
			slotGerarAbas(mywidget);
		}
		else if (list.value(0) == "ReadEstudos"){
			//Verifica se o estudo existe, visto que este pode ter sido renomeado em outra instncia
			if ( bancoUser.existEstudo(list.value(1), list.value(2)) ){
				ReadEstudos *mywidget = new ReadEstudos(list.value(1), list.value(2), list.value(3));
				mywidget->setParent(this, Qt::Window);
				slotGerarAbas(mywidget);
			}
		}
		else if (list.value(0) == "indiceAtual")
			aTabWidget->setCurrentIndex ( n1.toInt() );
			
		if (cont < maxId){
			n1.setValue(cont + 1);
			n2.setValue(maxId);
			splash->showMessage("Bem vindo  aBblia Software!\nAbrindo abas: " + n1.toString() + "/" + n2.toString() + "\n", Qt::AlignCenter | Qt::AlignBottom,  Qt::white);
			qApp->processEvents();
		}
		else {
			n1.setValue(cont);
			n2.setValue(maxId);
			splash->showMessage("Bem vindo  aBblia Software!\nAbrindo abas: " + n1.toString() + "/" + n2.toString() + "\n", Qt::AlignCenter | Qt::AlignBottom,  Qt::white);
			mutex.lock();
			waitC.wait(&mutex, 500);
			mutex.unlock();
			qApp->processEvents();
		}
	}
}
void abiblia::gravarEstadoAbas(){
	BancoUser bancoUser;
	
	//Apaga a tabela atual
	bancoUser.delEstadoAbas();
	
	int cont = 0;
	//Preenche uma nova tabela
	while (aTabWidget->widget(cont) != 0){
		if (ReadBiblia* read = qobject_cast<ReadBiblia*>(aTabWidget->widget(cont)) )
			bancoUser.setEstadoAbas(cont, "ReadBiblia", read->getLivroCapitulo(), "", "", read->getIdTestamento(), -1);
		
		else if (ReadPesquisa* read = qobject_cast<ReadPesquisa*>(aTabWidget->widget(cont)) )
			bancoUser.setEstadoAbas(cont, "ReadPesquisa", read->getPesquisa(), "", "", read->getIdTestamento(), read->getIdModo());
		
		else if (ReadPassagens* read = qobject_cast<ReadPassagens*>(aTabWidget->widget(cont)) )
			bancoUser.setEstadoAbas(cont, "ReadPassagens", read->getLivroCapitulo(), read->getPassagem(), "", read->getIdTestamento(), -1);
		
		else if (ReadEstudos* read = qobject_cast<ReadEstudos*>(aTabWidget->widget(cont)) ){
			if (read->getModo() != "c")
				bancoUser.setEstadoAbas(cont, "ReadEstudos", read->getCategoria(), read->getTitulo(), read->getModo(), -1, -1);
			else
				bancoUser.setEstadoAbas(cont, "ReadEstudos", "", "", read->getModo(), -1, -1);
		}
		cont++;
	}
	//Grava a atual aba ativa
	bancoUser.setEstadoAbas(cont, "indiceAtual", "", "", "", aTabWidget->currentIndex(), -1);
}
//Carregar configuraes de resoluo
void abiblia::carregarResolucao(){
	if (config.getResolucaoW() == 0 || config.getResolucaoH() == 0){
		setWindowState(Qt::WindowMaximized);
		config.setResolucao(0, 0);
	}
	else
		resize(config.getResolucaoW(), config.getResolucaoH());
}

//Redimencionador
void abiblia::resizeEvent(QResizeEvent * /*event*/){
	unsigned short int extraWidth = width() - minimumWidth();
	unsigned short int extraHeight = height() - minimumHeight();
	
	#if defined(__linux__)
		gbxBox->setGeometry(QRect( 10, 35, 681 + extraWidth, 90));
		aTabWidget->setGeometry( QRect( 10, 130, 681 + extraWidth, 521 + extraHeight) );
	#elif defined(_WIN32) || defined(__WIN32) || defined(WIN32) || defined(__WIN32__)
		gbxBox->setGeometry(QRect( 10, 25, 681 + extraWidth, 85));
		aTabWidget->setGeometry( QRect( 10, 120, 681 + extraWidth, 531 + extraHeight) );
	#endif
	
	if (isMaximized())
		config.setResolucao(0, 0);
	else
		config.setResolucao(width(), height());
}
//Fechar Janela
void abiblia::closeEvent(QCloseEvent *event){
	bool salvo = true;
	bool flag;
	int cont = 0;
	
	while (aTabWidget->widget(cont) != 0){
		if (ReadBiblia* read = qobject_cast<ReadBiblia*>(aTabWidget->widget(cont)) )
			if (read->getSalvo() == false)
				salvo = false;
				
		if (ReadEstudos* read = qobject_cast<ReadEstudos*>(aTabWidget->widget(cont)) ){
			if (read->getSalvo() == false)
				salvo = false;
		}
		cont++;
	}

	if (!salvo){
		AMessageBox aMsgBox;
		flag = aMsgBox.yesNo("Existem abas com contedos que no foram salvos.\nDeseja sair e perder estes contedos?", "Sair");
		if (flag == false){
			event->ignore();
		}
		else{
			gravarEstadoAbas();
			event->accept();
		}
	}
	else{
		gravarEstadoAbas();
		event->accept();
	}
}

abiblia::~abiblia() {
	// destrutor
}

