/******************************************************************************
CLASSE AFULLSCREEN
CRIADO: 04-11-2008
ALTERADO: 10-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "afullscreen.h"


AFullScreen::AFullScreen(const QString &strTexto, QFont fonte){
	unsigned short int FONTE_MEDIA = resolucao.getFonteMedia();
	QPixmap icon;
	
	// Tamanho, Ttulo e cone
	setMinimumSize( QSize( 600, 500 ) ); resize(600, 500);
	
	//Seta a fonte
	QFont fonteLabel = QFont("Bitstream", FONTE_MEDIA);
	
	comunidade = new QLabel("<a href=\"http://www.comunidadeabiblia.net\" style=\"text-decoration: none;\">"
							"<font color=#194DB4><b>www.comunidadeabiblia.net</b></font></a>", this);
	comunidade->setOpenExternalLinks(true);
	comunidade->setFont( fonteLabel );

	//Caixa de texto
	caixaTexto = new QTextBrowser(this);
	caixaTexto->setText(strTexto);
	caixaTexto->setFont( fonte );
	caixaTexto->setReadOnly(TRUE);
	
	sair = new QAction(tr("Sair do modo tela Inteira"), this);
	sair->setShortcut(tr("Esc"));
	sair->setStatusTip(tr("Fechar esta janela"));
	icon.load((const QString&)DIR_ICONS + "cancel.png");
	sair->setIcon(icon);

	arquivoMenu = new QMenu();
	arquivoMenu = menuBar()->addMenu(tr("&Arquivo"));
	arquivoMenu->addAction(sair);
	
	QObject::connect(sair,SIGNAL(triggered() ),this,SLOT(close() ) );
}


void AFullScreen::resizeEvent(QResizeEvent * /*event*/){
	int extraWidth = width() - minimumWidth();
	int extraHeight = height() - minimumHeight();

	comunidade->setGeometry(10, 480 + extraHeight, 250, 25);
	#if defined(__linux__)
		caixaTexto->setGeometry(10, 35, 580 + extraWidth, 440 + extraHeight);
	#elif defined(_WIN32) || defined(__WIN32) || defined(WIN32) || defined(__WIN32__)
		caixaTexto->setGeometry(10, 30, 580 + extraWidth, 440 + extraHeight);
	#endif
}

AFullScreen::~AFullScreen(){
	delete comunidade;
	delete caixaTexto;
}

