/******************************************************************************
CLASSE CONFIG
CRIADO: 25-11-2008
ALTERADO: 27-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "config.h"


Config::Config(){
}

void Config::setArqConfig(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line, campos;
	QTextStream stream;
	int flag = 0;

	campos = "HABILITAR_SECUNDARIO=1\nTEXTO_PRINCIPAL=RCF\n"
			 "TEXTO_SECUNDARIO=JFA\nBIBLIA_POINT_SIZE=9\n"
			 "ESTUDOS_POINT_SIZE=9\nHABILITAR_COMBO_LEITURA=1\n"
			 "PESQUISA_OPCOES=3\nMODO_COMBO_LEITURA=PADRAO\n"
			 "DIR_HOME=" + (const QString&)DIR_HOME + "\n"
			 "RESOLUCAO_W=0\nRESOLUCAO_H=0";

	if ( arqConfig.isEmpty() ){
		QString newArqConfig = campos;
		ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
	}
	else {
		stream.setString(&arqConfig, QIODevice::ReadWrite);
		while ( !stream.atEnd() ) {
			line = stream.readLine();
			if (line.contains("HABILITAR_SECUNDARIO=")){
				flag++;
			}
			else if (line.contains("TEXTO_PRINCIPAL=")){
				flag++;
			}
			else if (line.contains("TEXTO_SECUNDARIO=")){
				flag++;
			}
			else if (line.contains("BIBLIA_POINT_SIZE=")){
				flag++;
			}
			else if (line.contains("ESTUDOS_POINT_SIZE=")){
				flag++;
			}
			else if (line.contains("HABILITAR_COMBO_LEITURA=")){
				flag++;
			}
			else if (line.contains("PESQUISA_OPCOES=")){
				flag++;
			}
			else if (line.contains("MODO_COMBO_LEITURA=")){
				flag++;
			}
			else if (line.contains("DIR_HOME=")){
				flag++;
			}
			else if (line.contains("RESOLUCAO_W=")){
				flag++;
			}
			else if (line.contains("RESOLUCAO_H=")){
				flag++;
			}
		}
		if (flag != 11){
			QString newArqConfig = campos;
			ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
		}
	}
}
void Config::setCheckTextoSecundario(unsigned short int Config){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line;
	QTextStream stream;
	QString ConfigS;
	ConfigS.setNum(Config);

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("HABILITAR_SECUNDARIO="))
			line = "HABILITAR_SECUNDARIO=" + ConfigS;
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

bool Config::getCheckTextoSecundario(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
	if (line.contains("HABILITAR_SECUNDARIO=")){
			if (line == "HABILITAR_SECUNDARIO=1")
				return true;
			else
				return false;
		}
	}
	return false;
}

void Config::setTextoPrincipal(const QString &versao){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line, ver;
	QTextStream stream;

	if (versao == "J.F. Almeida Corrigida e Fiel (1994)")
		ver = "RCF";
	else if (versao == "J.F. Almeida Atualizada (1967)")
		ver = "JFA";

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("TEXTO_PRINCIPAL="))
			line = "TEXTO_PRINCIPAL=" + ver;
			newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

QString Config::getTextoPrincipal(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("TEXTO_PRINCIPAL=")){
			if (line == "TEXTO_PRINCIPAL=JFA")
				return "J.F. Almeida Atualizada (1967)";
			else if (line == "TEXTO_SECUNDARIO=RCF")
				return "J.F. Almeida Corrigida e Fiel (1994)";
		}
	}
	return "J.F. Almeida Corrigida e Fiel (1994)";
}

void Config::setTextoSecundario(const QString &versao){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line, ver;
	QTextStream stream;

	if (versao == "J.F. Almeida Corrigida e Fiel (1994)")
		ver = "RCF";
	else if (versao == "J.F. Almeida Atualizada (1967)")
		ver = "JFA";

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("TEXTO_SECUNDARIO="))
			line = "TEXTO_SECUNDARIO=" + ver;
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

QString Config::getTextoSecundario(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("TEXTO_SECUNDARIO=")){
			if (line == "TEXTO_SECUNDARIO=JFA")
				return "J.F. Almeida Atualizada (1967)";
			else if (line == "TEXTO_SECUNDARIO=RCF")
				return "J.F. Almeida Corrigida e Fiel (1994)";
		}
	}
	return "J.F. Almeida Atualizada (1967)";
}

void Config::setPointSizeTexto(short int pointSize, const QString& classe){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line, campo;
	QTextStream stream;

	campo = classe + "_POINT_SIZE="; //classe = BIBLIA ou ESTUDOS

	QVariant v;
	v.setValue(pointSize);

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(campo))
			line = campo + v.toString();
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

int Config::getPointSizeTexto(const QString& classe){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line, campo;
	QTextStream stream;
	QVariant v;

	campo = classe + "_POINT_SIZE="; //classe = BIBLIA ou ESTUDOS

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(campo)){
			v.setValue(line.section('=', 1, 1));
			break;
		}
	}
	return v.toInt();
}

void Config::setCheckComboLeitura(bool Config){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line;
	QTextStream stream;
	QString ConfigS;

	if (Config)
		ConfigS = "1";
	else
		ConfigS = "0";

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("HABILITAR_COMBO_LEITURA="))
			line = "HABILITAR_COMBO_LEITURA=" + ConfigS;
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

bool Config::getCheckComboLeitura(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadOnly);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("HABILITAR_COMBO_LEITURA=")){
			if (line == "HABILITAR_COMBO_LEITURA=1")
				return true;
			else
				return false;
		}
	}
	return false;
}

void Config::setModoComboLeitura(short int idModo){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line;
	QTextStream stream;
	QString ConfigS;

	if (idModo == PADRAO)
		ConfigS = "PADRAO";
	else
		ConfigS = "BASICO";

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("MODO_COMBO_LEITURA="))
			line = "MODO_COMBO_LEITURA=" + ConfigS;
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

int Config::getModoComboLeitura(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadOnly);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("MODO_COMBO_LEITURA=")){
			if (line == "MODO_COMBO_LEITURA=PADRAO")
				return PADRAO;
			else
				return BASICO;
		}
	}
	return PADRAO;
}

void Config::setPesquisaOpcoes(short int idModo){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line, campo;
	QTextStream stream;

	campo = "PESQUISA_OPCOES=";

	QVariant v;
	v.setValue(idModo);

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(campo))
			line = campo + v.toString();
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

int Config::getPesquisaOpcoes(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line, campo;
	QTextStream stream;
	QVariant v;

	campo = "PESQUISA_OPCOES="; 

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(campo)){
			v.setValue(line.section('=', 1, 1));
			break;
		}
	}
	return v.toInt();
}

void Config::setDirHome(const QString &strHome){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("DIR_HOME="))
			line = "DIR_HOME=" + strHome;
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

QString Config::getDirHome(){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line;
	QTextStream stream;

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains("DIR_HOME=")){
			return line.section("DIR_HOME=", 1, 1);
		}
	}
	return (const QString&)DIR_HOME;
}

void Config::setResolucao(short int w, short int h){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString newArqConfig, line, campoW, campoH;
	QTextStream stream;

	campoW = "RESOLUCAO_W=";
	campoH = "RESOLUCAO_H=";

	QVariant vW, vH;
	vW.setValue(w);
	vH.setValue(h);

	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(campoW))
			line = campoW + vW.toString();
		if (line.contains(campoH))
			line = campoH + vH.toString();
		newArqConfig += line + "\n";
	}
	ferramentas.rw(DIR_CONFIG_TEXTO, 'w', newArqConfig);
}

int Config::_getResolucao(char componente){
	QString arqConfig = ferramentas.rw(DIR_CONFIG_TEXTO,'r',"");
	QString line, campo;
	QTextStream stream;
	QVariant v;
	
	if (componente == 'w')
		campo = "RESOLUCAO_W=";
	else if(componente == 'h')
		campo = "RESOLUCAO_H=";
	
	stream.setString(&arqConfig, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(campo)){
			v.setValue(line.section('=', 1, 1));
			break;
		}
	}
	return v.toInt();
}

int Config::getResolucaoW(){
	return _getResolucao('w');
}

int Config::getResolucaoH(){
	return _getResolucao('h');
}

