/******************************************************************************
CLASSE DIALSOBRE
CRIADO: 31-10-2008
ALTERADO: 08-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "dialsobre.h"

#include "dialcreditos.h"


DialSobre::DialSobre():DialBase(){
	setWindowTitle("Sobre a " + (const QString&)NOME);
	setMinimumSize( QSize( 300, 400 ) );
	setMaximumSize( QSize( 300, 400 ) );

	QPixmap logo;
	logo.load((const QString&)DIR_IMAGES + "sobre.png");
	lblMain = new QLabel(this);
	lblMain->setPixmap(logo);

	QString v = VERSAO;
	lblVersao = new QLabel( "<font color=#ffffff><b>Verso " + v + "</b><br>" + (const QString&)DATA_VERSAO + "</font>", this );
	QFont fonte = QFont("Bitstream", FONTE_PEQUENA);
	lblVersao->setFont(fonte);
	lblVersao->setTextFormat( Qt::AutoText );
	lblVersao->setAlignment( Qt::AlignCenter );
	lblVersao->setWordWrap( TRUE );

	fonte = QFont("Bitstream", FONTE_MEDIA);
	lblDescricao = new QLabel( "aBblia Software  uma Bblia Sagrada Digital "
							"Open Source Verso Joo Ferreira de Almeida", this );
	fonte.setBold(FALSE);
	lblDescricao->setFont(fonte);
	lblDescricao->setTextFormat( Qt::AutoText );
	lblDescricao->setAlignment( Qt::AlignCenter );
	lblDescricao->setWordWrap( TRUE );

	lblCopyright = new QLabel( "Copyright  2007-2009 Luis Csar C. Vasquez", this );
	fonte = QFont("Bitstream", FONTE_PEQUENA);
	fonte.setBold(FALSE);
	lblCopyright->setFont(fonte);
	lblCopyright->setTextFormat( Qt::AutoText );
	lblCopyright->setAlignment( Qt::AlignCenter );
	lblCopyright->setWordWrap( TRUE );

	lblUrl = new QLabel("<a href=\"http://www.comunidadeabiblia.net\" style=\"text-decoration: none;\">"
						"<font color=#000000>http://comunidadeabiblia.net</font></a>", this);
	lblUrl->setOpenExternalLinks(true);
	lblUrl->setFont(fonte);
	lblUrl->setTextFormat( Qt::AutoText );
	lblUrl->setAlignment( Qt::AlignCenter );
	lblUrl->setWordWrap( TRUE );
	lblUrl->setToolTip("Visite nosso site!");

	btnCreditos = new QPushButton("Crditos", this);
	btnCreditos->setFont(fonte);
	connect(btnCreditos, SIGNAL(clicked() ), this, SLOT(exibirCreditos() ) );

	btnCancelar->setText("Ok");
	btnCancelar->setToolTip("Fechar este Formulrio");
	connect( btnCancelar, SIGNAL( clicked () ), this, SLOT(close() ) );
	
	lblMain->setGeometry( QRect( 0, 0, 300, 195) );
	lblVersao->setGeometry( QRect( 10, 157, 280, 40 ) );
	lblDescricao->setGeometry( QRect( 10, 200, 280, 60 ) );
	lblCopyright->setGeometry( QRect( 10, 250, 280, 60 ) );
	lblUrl->setGeometry( QRect( 10, 300, 280, 60 ) );
	btnCreditos->setGeometry( QRect(10, height() - 35, 90, 25 ) );
	
	btnCancelar->setGeometry( QRect( width() - 100, height() - 35, 90, 25 ) );
}

void DialSobre::exibirCreditos(){
	DialCreditos *mywidget = new DialCreditos();
	mywidget->setParent(this, Qt::Dialog);
	mywidget->show();
}

