/******************************************************************************
CLASSE FERRAMENTAS (CONJUNTO DE METODOS)
CRIADO: 09-2007
ALTERADO: 30-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "ferramentas.h"
#include "config.h"


Ferramentas::Ferramentas(){
}

QString  Ferramentas::rw (const QString &file, char modo, const QString &string){
	QString textoRW;
	QFile fileTxt;
	QTextStream streamTxt;

	if (modo == 'r'){
		fileTxt.setFileName(file);
		fileTxt.open(QIODevice::ReadOnly);
		streamTxt.setDevice(&fileTxt);
		streamTxt.setCodec(QTextCodec::codecForName("UTF-8"));
		textoRW = streamTxt.readAll();
		fileTxt.flush();
		fileTxt.close();
	}
	else if (modo == 'w'){
		fileTxt.setFileName(file);
		fileTxt.open(QIODevice::WriteOnly);
		streamTxt.setDevice(&fileTxt);
		streamTxt.setCodec(QTextCodec::codecForName("UTF-8"));
		streamTxt << string;
		fileTxt.flush();
		fileTxt.close();
	}
	return textoRW;
}

QString Ferramentas::separaCapitulos(const QString &capitulo, short int idTestamento, bool secundario){
	bool flag = false;
	QString resultado;
	QString line, texto;
	QString livro = capitulo.section( " ", 0, 0);

	if (idTestamento == VELHO_TESTAMENTO)
		texto = antigoTestamento(secundario);
	else if (idTestamento == NOVO_TESTAMENTO)
		texto = novoTestamento(secundario);
	else if (idTestamento == INDEFINIDO){
		int idTestamentoN = descobreTestamento( livro );
		if (idTestamentoN == VELHO_TESTAMENTO)
			texto = antigoTestamento(secundario);
		else if (idTestamentoN == NOVO_TESTAMENTO)
			texto = novoTestamento(secundario);
	}
	QTextStream stream;
	stream.setString(&texto, QIODevice::ReadOnly);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line == capitulo)
			flag = true;
		else if ( (line == "") && (flag) )
			break;
		if (flag)
			resultado += line + "\n";
	}
	return resultado;
}

int Ferramentas::descobreTestamento(const QString &c){
	short int idTestamento;

	if (c == "MATEUS" || c == "MARCOS" || c == "LUCAS" || c == "JOO" || c == "ATOS" || c == "ROMANOS" || c == "I CORNTIOS" || c == "II CORNTIOS" || c == "GLATAS" || c == "EFSIOS" || c == "FILIPENSES" || c == "COLOSSENSES" || c == "I TESSALONICENSES" || c == "II TESSALONICENSES" || c == "I TIMTEO" || c == "II TIMTEO" || c == "TITO" || c == "FILEMOM" || c == "HEBREUS" || c == "TIAGO" || c == "I PEDRO" || c == "II PEDRO" || c == "I JOO" || c == "II JOO" || c == "III JOO" || c == "JUDAS" || c == "APOCALIPSE")
		idTestamento = NOVO_TESTAMENTO;
	else
		idTestamento = VELHO_TESTAMENTO;

	return idTestamento;
}

QString Ferramentas::busca(const QString &pesquisa, short int idTestamento, short int idModo, bool secundario){
	unsigned short int qtdVer, flag, vezesPesquisa;
	bool flagCapitulo, flagAchou;
	QString resultado, capitulo;
	QString line, texto, testam;

	flagCapitulo = false;
	qtdVer = flag = 0;
	if (idTestamento == VELHO_TESTAMENTO){
		texto = antigoTestamento(secundario);
		testam = "no Antigo Testamento";
		vezesPesquisa = 1;
	}
	else if (idTestamento == NOVO_TESTAMENTO){
		texto = novoTestamento(secundario);
		testam = "no Novo Testamento";
		vezesPesquisa = 1;
	}
	else{ // idTestamento == BIBLIA
		texto = antigoTestamento(secundario);
		testam = "em toda a Bblia";
		vezesPesquisa = 2;
	}

	for (int p = 0; p < vezesPesquisa; p++){
		if ( (p == (vezesPesquisa - 1)) && (vezesPesquisa > 1) )
			texto = novoTestamento(secundario);
			
		QTextStream stream;
		stream.setString(&texto, QIODevice::ReadOnly);
		while ( !stream.atEnd() ) {
			line = stream.readLine();
			if (flag == 1){
				capitulo = line;
				flag = 2;
				flagCapitulo = true;
			}
			else if (line == "")
				flag = 1;
			else if (flag == 2){
				flagAchou = false;
				if (idModo == PESQUISA_NORMAL){
					if( (line.contains( pesquisa )) && (line != capitulo) )
						flagAchou = true;
				}
				else if (idModo == PESQUISA_MAIUS_MINUS){
					if( (line.contains(pesquisa, Qt::CaseInsensitive)) && (line != capitulo) )
						flagAchou = true;
				}
				else if (idModo == PESQUISA_SEM_ACENTOS){
					if( (semAcentos(line).contains( semAcentos(pesquisa) )) && (line != capitulo) )
						flagAchou = true;
				}
				else if (idModo == PESQUISA_MAIUS_MINUS_SEM_ACENTOS){
					if( (semAcentosMM(line).contains( semAcentosMM(pesquisa) )) && (line != capitulo) )
						flagAchou = true;
				}
				if (flagAchou){
					if (flagCapitulo == true){
							resultado += "\n" + capitulo + "\n";
							flagCapitulo = false;
						}
						resultado += line + "\n";
						qtdVer++;
				}
			}
		}
	}

	QString retorno;
	QString palavra;
	if (pesquisa.contains(" "))
		palavra = "frase";
	else
		palavra = "palavra";
	if (resultado == "")
		resultado = QString ("No foi encontrado nenhum versculo %2 contendo a %3 \"%1\":\n"
		"\nVerifique se voc digitou os termos corretos!").arg(pesquisa).arg(testam).arg(palavra);

	else if (qtdVer == 1)
		retorno = QString ("Foi encontrado 1 versculo %2 contendo a %3 \"%1\":\n").arg(pesquisa).arg(testam).arg(palavra);

	else if (qtdVer > 1)
		retorno = QString ("Foram encontrados %2 versculos %3 contendo a %4 \"%1\":\n").arg(pesquisa).arg(qtdVer).arg(testam).arg(palavra);

	return retorno + resultado;
}
QString Ferramentas::passagens(const QString &verso, short int idTestamento, bool secundario){
	unsigned short int flag = 0, ver1, ver2;
	QString capitulo, versiculo, resultado, line, v1, v2, texto;

	resultado = verso;
	capitulo = resultado.section( ": ", 0, 0)+":";
	versiculo = resultado.section( ": ", 1, 1);

	if (versiculo.contains("-")){ //Dois versculos
		v1 = versiculo.section( '-', 0, 0);
		v2 = versiculo.section( '-', 1, 1);
	}
	else
		v1 = v2 = versiculo;

	if (idTestamento == VELHO_TESTAMENTO)
			texto = antigoTestamento(secundario);
		else if (idTestamento == NOVO_TESTAMENTO)
			texto = novoTestamento(secundario);
	bool ok;
	ver1 = v1.toInt(&ok, 10);
	ver2 = v2.toInt(&ok, 10);

	QTextStream stream;
	stream.setString(&texto, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line == capitulo)
			flag = 2;
		if ( (line == "") && (flag) )
			break;
		if (flag){
			if (flag == 2){
				resultado += "\n";
				flag = 1;
			}
			else if(ver1 <= ver2){
				v1.setNum(ver1);
				if (line.contains(v1 + " ") ){
					resultado += line + "\n";
					ver1++;
				}
			}
		}
	}
	return resultado;
}

//Textos Bblicos
QString Ferramentas::novoTestamento(bool secundario){
	Config config;
	QString texto;
	if (!secundario){
		if (config.getTextoPrincipal() == "J.F. Almeida Corrigida e Fiel (1994)")
		texto = rw(DIR_NOVO_JFARCF, 'r', "");
	else if (config.getTextoPrincipal() == "J.F. Almeida Atualizada (1967)")
		texto = rw(DIR_NOVO_JFA, 'r', "");
	}
	else{
		if (config.getTextoSecundario() == "J.F. Almeida Corrigida e Fiel (1994)")
			texto = rw(DIR_NOVO_JFARCF, 'r', "");
		else if (config.getTextoSecundario() == "J.F. Almeida Atualizada (1967)")
			texto = rw(DIR_NOVO_JFA, 'r', "");
	}
	return texto;
}

QString Ferramentas::antigoTestamento(bool secundario){
	Config config;
	QString texto;
	if (!secundario){
		if (config.getTextoPrincipal() == "J.F. Almeida Corrigida e Fiel (1994)")
			texto = rw(DIR_VELHO_JFARCF, 'r', "");
		else if (config.getTextoPrincipal() == "J.F. Almeida Atualizada (1967)")
			texto = rw(DIR_VELHO_JFA, 'r', "");
	}
	else{
		if (config.getTextoSecundario() == "J.F. Almeida Corrigida e Fiel (1994)")
			texto = rw(DIR_VELHO_JFARCF, 'r', "");
		else if (config.getTextoSecundario() == "J.F. Almeida Atualizada (1967)")
			texto = rw(DIR_VELHO_JFA, 'r', "");
	}
	return texto;
}

//Complementos de ferramentas
QString Ferramentas::semAcentos(const QString &texto){
	QString _texto = texto;
	for (int cont = 0; cont < _texto.length(); cont++){
		if ( !( (_texto[cont] >= 65) && (_texto[cont] <= 90) ) && 
			 !( (_texto[cont] >= 97) && (_texto[cont] <= 122) ) ){
			 
			if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'a';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'e';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'i';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'o';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'u';
			}
			else if( (_texto[cont] == '') ){
				_texto[cont] = 'c';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'A';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'E';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'I';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'O';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'U';
			}
			else if( (_texto[cont] == '') ){
				_texto[cont] = 'C';
			}

		}
	}
	return _texto;
}
QString Ferramentas::semAcentosMM(const QString &texto){
	QString _texto = texto.toUpper();
	for (int cont = 0; cont < _texto.length(); cont++){
		if ( !( (_texto[cont] >= 65) && (_texto[cont] <= 90) ) && 
			 !( (_texto[cont] >= 97) && (_texto[cont] <= 122) ) ){
				
			if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'A';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'E';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'I';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'O';
			}
			else if( (_texto[cont] >= '') && (_texto[cont] <= '') ){
				_texto[cont] = 'U';
			}
			else if( (_texto[cont] == '') ){
				_texto[cont] = 'C';
			}
		}
		
	}
	return _texto;
}

Ferramentas::~Ferramentas(){
	//delete this;
}

