/******************************************************************************
CLASSE FRMPASSAGENS
CRIADO: 21-10-2008
ALTERADO: 15-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "frmpassagens.h"

FrmPassagens::FrmPassagens():FrmBase(){
	setWindowTitle("Passagens - " + (const QString&)NOME);
	setMinimumSize( QSize( 400, 330 ) );
	resize(400, 330);
	
	fonte = QFont("Bitstream", FONTE_MEDIA);
	boxAntTestamento = new QGroupBox( "boxAntTestamento", this );
	boxAntTestamento->setTitle("Passagens do Antigo Testamento");
	boxAntTestamento->setFont(fonte);

	fonte = QFont("Bitstream", FONTE_PEQUENA);
	lblPassagemAntTestamento = new QLabel("Passagem",boxAntTestamento);
	lblPassagemAntTestamento->setFont(fonte);
	lblPassagemAntTestamento->setAlignment( Qt::AlignLeft );
	lblPassagemAntTestamento->setWordWrap(true);

	lblReferenciasAntTestamento = new QLabel("Referncia(s)",boxAntTestamento);
	lblReferenciasAntTestamento->setFont(fonte);
	lblReferenciasAntTestamento->setAlignment( Qt::AlignLeft );
	lblReferenciasAntTestamento->setWordWrap(true);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	cbxPassagemAntTestamento = new QComboBox( boxAntTestamento );
	cbxPassagemAntTestamento->setFont(fonte);
	cbxPassagemAntTestamento->setToolTip("Passagens do Antigo Testamento");

	ledQtdReferenciasAntTestamento = new QLineEdit( boxAntTestamento );
	ledQtdReferenciasAntTestamento->setReadOnly(true);
	ledQtdReferenciasAntTestamento->setFont(fonte);
	ledQtdReferenciasAntTestamento->setToolTip("Quantidade de referncias da\npassagem selecionada");

	cbxReferenciaAntTestamento = new QComboBox( boxAntTestamento );
	cbxReferenciaAntTestamento->setFont(fonte);
	cbxReferenciaAntTestamento->setToolTip("Referncias da passagem selecionada");

	btnPassagemAntTestamento = new QPushButton( "btnPassagemAntTestamento", boxAntTestamento );
	btnPassagemAntTestamento->setFont(fonte);
	btnPassagemAntTestamento->setText( tr( "Ler" ) );
	btnPassagemAntTestamento->setToolTip("Ler referncia selecionada");

	fonte = QFont("Bitstream", FONTE_MEDIA);
	boxNovoTestamento = new QGroupBox( "boxAntTestamento", this );
	boxNovoTestamento->setTitle("Passagens do Novo Testamento");
	boxNovoTestamento->setFont(fonte);
	
	fonte = QFont("Bitstream", FONTE_PEQUENA);
	lblPassagemNovoTestamento = new QLabel("Passagem", boxNovoTestamento);
	lblPassagemNovoTestamento->setFont(fonte);
	lblPassagemNovoTestamento->setAlignment( Qt::AlignLeft  );
	lblPassagemNovoTestamento->setWordWrap(true);

	lblReferenciasNovoTestamento = new QLabel("Referncia(s)", boxNovoTestamento);
	lblReferenciasNovoTestamento->setFont(fonte);
	lblReferenciasNovoTestamento->setAlignment( Qt::AlignLeft );
	lblReferenciasNovoTestamento->setWordWrap(true);
	
	fonte = QFont("Bitstream", FONTE_MEDIA);
	cbxPassagemNovoTestamento = new QComboBox( boxNovoTestamento );
	cbxPassagemNovoTestamento->setFont(fonte);
	cbxPassagemNovoTestamento->setToolTip("Passagens do Novo Testamento");

	ledQtdReferenciasNovoTestamento = new QLineEdit( boxNovoTestamento );
	ledQtdReferenciasNovoTestamento->setReadOnly(true);
	ledQtdReferenciasNovoTestamento->setFont(fonte);
	ledQtdReferenciasNovoTestamento->setToolTip("Quantidade de referncias da\npassagem selecionada");

	cbxReferenciaNovoTestamento = new QComboBox( boxNovoTestamento );
	cbxReferenciaNovoTestamento->setFont(fonte);
	cbxReferenciaNovoTestamento->setToolTip("Referncias da passagem selecionada");

	btnPassagemNovoTestamento = new QPushButton( "btnPassagemNovoTestamento", boxNovoTestamento );
	btnPassagemNovoTestamento->setFont(fonte);
	btnPassagemNovoTestamento->setText( tr( "Ler" ) );
	btnPassagemNovoTestamento->setToolTip("Ler referncia selecionada");
	
	definirObjetosCancelar();

	carregarcbxPassagemAntTestamento();
	carregarcbxReferenciaAntTestamento();
	carregarcbxPassagemNovoTestamento();

	connect( cbxPassagemAntTestamento, SIGNAL( activated (const QString&) ), this, SLOT(carregarcbxReferenciaAntTestamento() ) );
	connect( cbxReferenciaAntTestamento, SIGNAL( activated (const QString&) ), this, SLOT(setPpDefault() ) );
	connect( btnPassagemAntTestamento, SIGNAL( clicked () ), this, SLOT(chamarPpPassagens() ) );
	connect( cbxPassagemNovoTestamento, SIGNAL( activated (const QString&) ), this, SLOT(carregarcbxReferenciaNovoTestamento() ) );
	connect( cbxReferenciaNovoTestamento, SIGNAL( activated (const QString&) ), this, SLOT(setJcDefault() ) );
	connect( btnPassagemNovoTestamento, SIGNAL( clicked () ), this, SLOT(chamarJcPassagens() ) );
}

//Passagens
void FrmPassagens::carregarcbxPassagemAntTestamento(){
	BancoSystem bancoSystem;
	cbxReferenciaAntTestamento->clear();
	cbxPassagemAntTestamento->addItems(bancoSystem.getPassagens(0));
	ledQtdReferenciasAntTestamento->setText(bancoSystem.getQtdRegistrosPassagens(cbxPassagemAntTestamento->currentText(), 0));
	cbxReferenciaAntTestamento->addItems(bancoSystem.getRegistrosPassagens(cbxPassagemAntTestamento->currentText(), 0));
}
void FrmPassagens::carregarcbxReferenciaAntTestamento(){
	BancoSystem bancoSystem;
	btnPassagemAntTestamento->setDefault(true);
	btnPassagemNovoTestamento->setDefault(false);

	cbxReferenciaAntTestamento->clear();
	ledQtdReferenciasAntTestamento->setText(bancoSystem.getQtdRegistrosPassagens(cbxPassagemAntTestamento->currentText(), 0));
	cbxReferenciaAntTestamento->addItems(bancoSystem.getRegistrosPassagens(cbxPassagemAntTestamento->currentText(), 0));
}
void FrmPassagens::chamarPpPassagens(){
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadPassagens *mywidget = new ReadPassagens(cbxReferenciaAntTestamento->currentText(), VELHO_TESTAMENTO, cbxPassagemAntTestamento->currentText() + ":\n\n");
	qApp->restoreOverrideCursor();
	mywidget->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(mywidget);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmPassagens::setPpDefault(){
	btnPassagemAntTestamento->setDefault(true);
	btnPassagemNovoTestamento->setDefault(false);
}

void FrmPassagens::carregarcbxPassagemNovoTestamento(){
	BancoSystem bancoSystem;
	cbxReferenciaNovoTestamento->clear();
	cbxPassagemNovoTestamento->addItems(bancoSystem.getPassagens(1));
	ledQtdReferenciasNovoTestamento->setText(bancoSystem.getQtdRegistrosPassagens(cbxPassagemNovoTestamento->currentText(), 1));
	cbxReferenciaNovoTestamento->addItems(bancoSystem.getRegistrosPassagens(cbxPassagemNovoTestamento->currentText(), 1));
}
void FrmPassagens::carregarcbxReferenciaNovoTestamento(){
	BancoSystem bancoSystem;
	btnPassagemNovoTestamento->setDefault(true);
	btnPassagemAntTestamento->setDefault(false);

	cbxReferenciaNovoTestamento->clear();
	ledQtdReferenciasNovoTestamento->setText(bancoSystem.getQtdRegistrosPassagens(cbxPassagemNovoTestamento->currentText(), 1));
	cbxReferenciaNovoTestamento->addItems(bancoSystem.getRegistrosPassagens(cbxPassagemNovoTestamento->currentText(), 1));
}
void FrmPassagens::chamarJcPassagens(){
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadPassagens *mywidget = new ReadPassagens(cbxReferenciaNovoTestamento->currentText(), NOVO_TESTAMENTO, cbxPassagemNovoTestamento->currentText() + ":\n\n");
	qApp->restoreOverrideCursor();
	mywidget->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(mywidget);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmPassagens::setJcDefault(){
	btnPassagemAntTestamento->setDefault(false);
	btnPassagemNovoTestamento->setDefault(true);
}

//Redimencionador
void FrmPassagens::resizeEvent(QResizeEvent * /*event*/){
	unsigned short int extraWidth = width() - minimumWidth();
	unsigned short int extraHeight = height() - minimumHeight();

	boxAntTestamento->setGeometry( QRect( 10, 10, 380 + extraWidth, 130 + extraHeight/2) );
	lblPassagemAntTestamento->setGeometry( QRect( 10, 30, 160, 25 ) );
	cbxPassagemAntTestamento->setGeometry( QRect( 10, 45, 360 + extraWidth, 25 ) );
	lblReferenciasAntTestamento->setGeometry( QRect( 10, 80, 160, 25 ) );
	ledQtdReferenciasAntTestamento->setGeometry( QRect( 10, 95, 25, 25 ) );
	cbxReferenciaAntTestamento->setGeometry( QRect( 45, 95, 245 + extraWidth, 25 ) );
	btnPassagemAntTestamento->setGeometry( QRect( 300 + extraWidth, 95, 70, 25 ) );
	
	boxNovoTestamento->setGeometry( QRect( 10, 150 + extraHeight/2, 380 + extraWidth, 130 + extraHeight/2) );
	lblPassagemNovoTestamento->setGeometry( QRect( 10, 30, 160, 25 ) );
	cbxPassagemNovoTestamento->setGeometry( QRect( 10, 45, 360 + extraWidth, 25 ) );
	lblReferenciasNovoTestamento->setGeometry( QRect( 10, 80, 160, 25 ) );
	ledQtdReferenciasNovoTestamento->setGeometry( QRect( 10, 95, 25, 25 ) );
	cbxReferenciaNovoTestamento->setGeometry( QRect( 45, 95, 245 + extraWidth, 25 ) );
	btnPassagemNovoTestamento->setGeometry( QRect( 300 + extraWidth, 95, 70, 25 ) );
	
	btnCancelar->setGeometry( QRect( width() - 80, height() - 35, 70, 25 ) );
	chkFecharAlto->setGeometry( QRect( 10, height() - 30, 200, 25) );
}

