/******************************************************************************
CLASSE FRMPESQUISA
CRIADO: 21-10-2008
ALTERADO: 15-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "frmpesquisa.h"

FrmPesquisa::FrmPesquisa():FrmBase(){
	setWindowTitle("Pesquisar - " + (const QString&)NOME);
	setMinimumSize( QSize( 400, 260 ) );
	resize(400, 230);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	boxPesquisa = new QGroupBox( "boxPesquisa", this );
	boxPesquisa->setTitle("Pesquisar versculos");
	boxPesquisa->setFont(fonte);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	ledPesquisa = new QLineEdit ( boxPesquisa );
	ledPesquisa->setFont(fonte);
	ledPesquisa->setToolTip("Termo a ser pesquisado\nnos versculos do universo\nselecionado");
	ledPesquisa->setFocus(Qt::ActiveWindowFocusReason);
	
	boxPesquisaTestamento = new QGroupBox( "boxPesquisaTestamento", this );
	boxPesquisaTestamento->setTitle("Escolha o testamento");
	boxPesquisaTestamento->setFont(fonte);
	boxPesquisaTestamento->setToolTip("Universo de pesquisa");
	radioBibliaPesquisa = new QRadioButton("Bblia Sagrada", boxPesquisaTestamento);
	radioBibliaPesquisa->setChecked(true);
	radioBibliaPesquisa->setFont(fonte);
	radioVelhoPesquisa = new QRadioButton("Antigo Testamento", boxPesquisaTestamento);
	radioVelhoPesquisa->setFont(fonte);
	radioNovoPesquisa = new QRadioButton("Novo Testamento", boxPesquisaTestamento);
	radioNovoPesquisa->setFont(fonte);
	
	boxPesquisaOpcoes = new QGroupBox( "boxPesquisaOpcoes", this );
	boxPesquisaOpcoes->setTitle("Opes");
	boxPesquisaOpcoes->setFont(fonte);
	boxPesquisaOpcoes->setToolTip("Opes de pesquisa");
	chkIgnorarMM = new QCheckBox("Ignorar mais/mins", boxPesquisaOpcoes);
	chkIgnorarMM->setFont(fonte);
	chkIgnorarAcentos = new QCheckBox("Ignorar acentos", boxPesquisaOpcoes);
	chkIgnorarAcentos->setFont(fonte);
	
	setCheckOpcoes();

	btnPesquisa = new QPushButton ( "btnPesquisa", boxPesquisa  );
	btnPesquisa->setFont(fonte);
	btnPesquisa->setText( tr( "Pesquisar" ) );
	btnPesquisa->setEnabled(false);
	btnPesquisa->setToolTip("Pesquisar termo");
	
	definirObjetosCancelar();

	connect( radioBibliaPesquisa, SIGNAL( clicked() ), this, SLOT( setTrueBibliaPesquisa() ) );
	connect( radioVelhoPesquisa, SIGNAL( clicked() ), this, SLOT( setTrueVelhoPesquisa() ) );
	connect( radioNovoPesquisa, SIGNAL( clicked() ), this, SLOT( setTrueNovoPesquisa() ) );
	connect( btnPesquisa, SIGNAL( clicked() ), this, SLOT( carregarPesquisa() ) );
	connect( ledPesquisa, SIGNAL( returnPressed() ), this, SLOT( carregarPesquisa() ) );
	connect( ledPesquisa, SIGNAL( textChanged(const QString &) ), this, 
		SLOT( slotHabilitarBotaoPesquisa(const QString &) ) );

}

//Pesquisa
void FrmPesquisa::slotHabilitarBotaoPesquisa(const QString &){
	if (ledPesquisa->text().trimmed().isEmpty())
		btnPesquisa->setEnabled(false);
	else
		btnPesquisa->setEnabled(true);
}
void FrmPesquisa::carregarPesquisa(){
	if (!ledPesquisa->text().trimmed().isEmpty()){
		short int idTestamento = BIBLIA;
		if (radioBibliaPesquisa->isChecked())
			idTestamento = BIBLIA;
		else if (radioVelhoPesquisa->isChecked())
			idTestamento = VELHO_TESTAMENTO;
		else if (radioNovoPesquisa->isChecked())
			idTestamento = NOVO_TESTAMENTO;
		
		qApp->setOverrideCursor( Qt::WaitCursor );
		ReadPesquisa *mywidget = new ReadPesquisa(ledPesquisa->text(), idTestamento, getCheckOpcoes());
		qApp->restoreOverrideCursor();
		mywidget->setParent(this->parentWidget(), Qt::Window);
		emit novaJanela(mywidget);
		if (chkFecharAlto->isChecked())
		close();
	}
}
void FrmPesquisa::setTrueBibliaPesquisa(){
	radioBibliaPesquisa->setChecked(true);
	radioVelhoPesquisa->setChecked(false);
	radioNovoPesquisa->setChecked(false);
}
void FrmPesquisa::setTrueNovoPesquisa(){
	radioNovoPesquisa->setChecked(true);
	radioBibliaPesquisa->setChecked(false);
	radioVelhoPesquisa->setChecked(false);

}
void FrmPesquisa::setTrueVelhoPesquisa(){
	radioVelhoPesquisa->setChecked(true);
	radioBibliaPesquisa->setChecked(false);
	radioNovoPesquisa->setChecked(false);
}
int FrmPesquisa::getCheckOpcoes(){
	int idModo = 0;
	if (!chkIgnorarMM->isChecked() && !chkIgnorarAcentos->isChecked())
		idModo = PESQUISA_NORMAL;
	else if (chkIgnorarMM->isChecked() && !chkIgnorarAcentos->isChecked())
		idModo = PESQUISA_MAIUS_MINUS;
	else if (!chkIgnorarMM->isChecked() && chkIgnorarAcentos->isChecked())
		idModo = PESQUISA_SEM_ACENTOS;
	else if (chkIgnorarMM->isChecked() && chkIgnorarAcentos->isChecked())
		idModo = PESQUISA_MAIUS_MINUS_SEM_ACENTOS;
		
	config.setPesquisaOpcoes(idModo);
	
	return idModo;
}
void FrmPesquisa::setCheckOpcoes(){
	int idModo = config.getPesquisaOpcoes();
	switch(idModo){
		case PESQUISA_NORMAL:
			chkIgnorarMM->setChecked(false);
			chkIgnorarAcentos->setChecked(false);
			break;
		case PESQUISA_MAIUS_MINUS:
			chkIgnorarMM->setChecked(true);
			chkIgnorarAcentos->setChecked(false);
			break;
		case PESQUISA_SEM_ACENTOS:
			chkIgnorarMM->setChecked(false);
			chkIgnorarAcentos->setChecked(true);
			break;
		case PESQUISA_MAIUS_MINUS_SEM_ACENTOS:
			chkIgnorarMM->setChecked(true);
			chkIgnorarAcentos->setChecked(true);
			break;
	}
}

//Redimencionador
void FrmPesquisa::resizeEvent(QResizeEvent * /*event*/){
	unsigned short int extraWidth = width() - minimumWidth();
	unsigned short int extraHeight = height() - minimumHeight();

	boxPesquisa->setGeometry( QRect( 10, 10, 381 + extraWidth, 80 + extraHeight/2) );
	ledPesquisa->setGeometry( QRect( 10, 30, 270 + extraWidth, 25 ) );
	btnPesquisa->setGeometry( QRect( 290 + extraWidth, 30, 80, 25 ) );
	boxPesquisaTestamento->setGeometry( QRect( 10, 100 + extraHeight/2, 180 + extraWidth/2, 110 + extraHeight/2) );
	radioBibliaPesquisa->setGeometry( QRect( 10, 20, 160, 25) );
	radioVelhoPesquisa->setGeometry( QRect( 10, 50, 160, 25) );
	radioNovoPesquisa->setGeometry( QRect( 10, 80, 160, 25) );
	boxPesquisaOpcoes->setGeometry( QRect( 210 + extraWidth/2, 100 + extraHeight/2, 180 + extraWidth/2, 80 + extraHeight/2) );
	chkIgnorarMM->setGeometry( QRect( 10, 20, 160, 25) );
	chkIgnorarAcentos->setGeometry( QRect( 10, 50, 160, 25) );
	
	btnCancelar->setGeometry( QRect( width() - 80, height() - 35, 70, 25 ) );
	chkFecharAlto->setGeometry( QRect( 10, height() - 30, 200, 25) );
}

