/******************************************************************************
CLASSE READ (CLASSE PAI)
CRIADO: 28-05-2008
ALTERADO: 10-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "read.h"
#include "afullscreen.h"

Read::Read():QMainWindow(){
	resolucao.lerResolucao();
	//int FONTE_GRANDE = resolucao.getFonteGrande();
	int FONTE_MEDIA = resolucao.getFonteMedia();
	//int FONTE_PEQUENA = resolucao.getFontePequena();
	// Tamanho, Ttulo e cone
	setWindowState(Qt::WindowMaximized);
	icon.load((const QString&)DIR_ICONS + "icon.png");
	setWindowIcon(icon);

	_salvo = true;

	QFont fonte = QFont("Bitstream", FONTE_MEDIA);
	//Endereo web
	comunidade = new QLabel("<a href=\"http://www.comunidadeabiblia.net\" style=\"text-decoration: none;\">"
							"<font color=#194DB4><b>www.comunidadeabiblia.net</b></font></a>", this);
	comunidade->setOpenExternalLinks(true);
	comunidade->setFont( fonte );
	comunidade->setToolTip("Visite nosso site!");

	//Caixa de texto
	caixaTexto = new QTextBrowser(this);
	caixaTexto->setReadOnly(true);
	caixaTexto->setOpenExternalLinks(true);
	caixaTexto->setUndoRedoEnabled(true);

	//Menus
	//ledProcurar = new QLineEdit(this);
	//ledProcurar->hide();

	aumentarFonte = new QAction(tr("A&+  (Aumentar fonte)"), this);
	aumentarFonte->setShortcut(tr("Ctrl++"));
	aumentarFonte->setStatusTip(tr("Aumenta o tamanho da fonte"));

	diminuirFonte = new QAction(tr("A&-  (Diminuir fonte)"), this);
	diminuirFonte->setShortcut(tr("Ctrl+-"));
	diminuirFonte->setStatusTip(tr("Diminuir o tamanho da fonte"));

	actFontePadrao = new QAction(tr("A  (Fonte padro)"), this);
	diminuirFonte->setStatusTip(tr("Altera o tamanho da fonte para o padro"));

  	/*actProcurarToken = new QAction(tr("F3  (Procurar)"), this);
	actProcurarToken->setShortcut(tr("F3"));
	actProcurarToken->setStatusTip(tr("Procurar termos neste texto"));
	QObject::connect(actProcurarToken,SIGNAL(triggered() ),this, SLOT(slotExibirProcurarToken() ) );*/

	exibirTelaInteira = new QAction(tr("Tela inteira"), this);
	exibirTelaInteira->setShortcut(tr("F11"));
	exibirTelaInteira->setStatusTip(tr("Exibio em tela inteira"));
	QObject::connect(exibirTelaInteira,SIGNAL(triggered() ),this, SLOT(slotTelaInteira() ) );

	imprimir = new QAction(tr("Im&primir"), this);
	imprimir->setShortcut(tr("Ctrl+P"));
	imprimir->setStatusTip(tr("Imprimir o texto"));
	icon.load((const QString&)DIR_ICONS + "print.png");
	imprimir->setIcon(icon);
	QObject::connect(imprimir,SIGNAL(triggered() ),this, SLOT(slotImprimir() ) );
	
	sair = new QAction(tr("Sair desta leitura"), this);
	sair->setShortcut(tr("Ctrl+Q"));
	sair->setStatusTip(tr("Fechar esta janela"));
	icon.load((const QString&)DIR_ICONS + "cancel.png");
	sair->setIcon(icon);
	QObject::connect(sair,SIGNAL(triggered() ),this,SLOT(close() ) );

	arquivoMenu = new QMenu();
	arquivoMenu = menuBar()->addMenu(tr("&Arquivo"));
	arquivoMenu->addAction(imprimir);
	arquivoMenu->addSeparator();
	arquivoMenu->addAction(sair);

	exibirMenu = new QMenu();
	exibirMenu = menuBar()->addMenu(tr("&Exibir"));
	exibirMenu->addAction(aumentarFonte);
	exibirMenu->addAction(diminuirFonte);
	exibirMenu->addAction(actFontePadrao);
  	//exibirMenu->addAction(actProcurarToken);
	exibirMenu->addSeparator();
	exibirMenu->addAction(exibirTelaInteira);

}
bool Read::getSalvo(){
	return _salvo;
}
void Read::setSalvo(bool s){
	_salvo = s;
}

//Menus
void Read::slotTelaInteira(){
	fullScreen = new AFullScreen(caixaTexto->toHtml(), fonte);
	fullScreen->show();
	fullScreen->showFullScreen();
}

/*void Read::slotExibirProcurarToken(){

	ledProcurar->show();
	ledProcurar->setGeometry(1, 35, 80, 15);
	QObject::connect(ledProcurar,SIGNAL(editingFinished() ),this,SLOT(procurarToken() ) );
}
void Read::procurarToken(){
	QString line, resultado, texto = caixaTexto->toHtml(), token = ledProcurar->text();
	QTextStream stream;
	stream.setString(&texto, QIODevice::ReadWrite);
	while ( !stream.atEnd() ) {
		line = stream.readLine();
		if (line.contains(token)){
			line = "<b>" + line + "</b>";
		}
		resultado +=line + "<br>";
	}
	caixaTexto->setHtml("teste<br>" + resultado);
}*/

Read::~Read(){
	close();
}

