/******************************************************************************
CLASSE READBIBLICO
CRIADO: 23-10-2008
ALTERADO: 30-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "readbiblico.h"


ReadBiblico::ReadBiblico():Read(){
	// Tamanho, Ttulo e cone
	setMinimumSize( QSize( 600, 500 ) ); resize(600, 500);
	
	labelTexto = new QLabel(this);
	labelTexto->setFont( fonte );
	labelTexto->setAlignment(Qt::AlignCenter);
	
	QObject::connect(aumentarFonte,SIGNAL(triggered() ),this, SLOT(slotZoomIn() ) );
	QObject::connect(diminuirFonte,SIGNAL(triggered() ),this, SLOT(slotZoomOut() ) );
	QObject::connect(actFontePadrao,SIGNAL(triggered() ),this, SLOT(slotZoomDefault() ) );
}


//Menus
void ReadBiblico::slotZoomIn(){
	caixaTexto->zoomIn();
	if (config.getCheckTextoSecundario())
		caixaTextoSecundario->zoomIn();
	
	QFont fonteAtual = caixaTexto->currentFont();
	short int pointSize = fonteAtual.pointSize();
	config.setPointSizeTexto(pointSize, "BIBLIA");
}
void ReadBiblico::slotZoomOut(){
	caixaTexto->zoomOut();
	if (config.getCheckTextoSecundario())
		caixaTextoSecundario->zoomOut();
	
	QFont fonteAtual = caixaTexto->currentFont();
	short int pointSize = fonteAtual.pointSize();
	config.setPointSizeTexto(pointSize, "BIBLIA");
}
void ReadBiblico::slotZoomDefault(){
	config.setPointSizeTexto(resolucao.getFonteMedia(), "BIBLIA");
	QFont fonte = QFont("Bitstream", config.getPointSizeTexto("BIBLIA"));
	caixaTexto->setFont( fonte );
	if (config.getCheckTextoSecundario())
		caixaTextoSecundario->setFont( fonte );
}
void ReadBiblico::resizeEvent(QResizeEvent * /*event*/){
	int extraWidth = width() - minimumWidth();
	int extraHeight = height() - minimumHeight();

	comunidade->setGeometry(10, 480 + extraHeight, 250, 21 + 4);

	if (!config.getCheckTextoSecundario()){
		labelTexto->setGeometry(10, 33, 580 + extraWidth, 15);
		caixaTexto->setGeometry(10, 50, 580 + extraWidth, 430 + extraHeight);
	}
	else {
		labelTexto->setGeometry(10, 33, (580 + extraWidth)/2, 15);
		caixaTexto->setGeometry(10, 50, (580 + extraWidth)/2, 430 + extraHeight);
		labelTextoSecundario->setGeometry((580 + extraWidth)/2 + 10, 33, (580 + extraWidth)/2, 15);
		caixaTextoSecundario->setGeometry((580 + extraWidth)/2 + 10, 50, (580 + extraWidth)/2, 430 + extraHeight);
	}
}

void ReadBiblico::prepareLivroCapitulo(const QString &strLivroCapitulo){
	int intPosicaoEspaco = 0, i;
	for (i = 0; i < strLivroCapitulo.length(); i++)
		if (strLivroCapitulo[i] == ' ')
		intPosicaoEspaco = i;
	strLivro = strLivroCapitulo.mid(0, intPosicaoEspaco).trimmed();
	strCapitulo = strLivroCapitulo.mid(intPosicaoEspaco).trimmed();
}

//Fechar Janela
void ReadBiblico::closeEvent(QCloseEvent *event){
	int flag = 0;
	if (!getSalvo()){
		AMessageBox aMsgBox;
		flag = aMsgBox.yesNoCancel("O texto no foi salvo.\nDeseja salv-lo agora?", "Sair");
		if (flag == 0){
			liberarMemoria();
			event->ignore(); emit finalizado(); //Ignore, ser finalizado pela aplicaao Pai
		}
		else if (flag == 1){
			emit salvarTexto();
			liberarMemoria();
			event->ignore(); emit finalizado();
		}
		else
			event->ignore();
	}
	else {
		liberarMemoria();
		event->ignore(); emit finalizado();
	}
}

void ReadBiblico::liberarMemoria(){
	delete comunidade;
	delete labelTexto;
	delete caixaTexto;

	if (config.getCheckTextoSecundario()){
		delete labelTextoSecundario;
		delete caixaTextoSecundario;
	}
}

ReadBiblico::~ReadBiblico(){
	close();
}

