/******************************************************************************
CLASSE READPASSAGENS
CRIADO: 23-10-2008
ALTERADO: 23-10-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "readpassagens.h"
#include "ferramentas.h"

ReadPassagens::ReadPassagens(const QString &strLivroCapitulo, short int idTestamento, const QString &strPassagem):ReadBiblico(){
	unsigned short int FONTE_MEDIA = resolucao.getFonteMedia();
	_strLivroCapitulo = strLivroCapitulo;
	_idTestamento = idTestamento;
	_strPassagem = strPassagem;

	// Tamanho, Ttulo e cone
	setMinimumSize( QSize( 600, 500 ) ); resize(600, 500);
	
	//Carrega as variveis strLivro e strCapitulo
	prepareLivroCapitulo(strLivroCapitulo);
	
	//Seta o ttulo da Janela
	//Retira ": \n" de strPassagem 
	setWindowTitle(strPassagem.mid(0, strPassagem.length() - 3).trimmed());
	
	//Seta a fonte
	fonte = QFont("Bitstream", FONTE_MEDIA);

	//Caixa de texto
	labelTexto->setText(config.getTextoPrincipal());
	caixaTexto->setText(carregarTexto(strLivroCapitulo, idTestamento, strPassagem, TEXTO_PRIMARIO));
	fonte = QFont("Bitstream", config.getPointSizeTexto("BIBLIA"));
	caixaTexto->setFont( fonte );
	fonte = QFont("Bitstream", FONTE_MEDIA);
	caixaTexto->setReadOnly(TRUE);

	//Caixa de texto Auxiliar
	fonte = QFont("Bitstream", FONTE_MEDIA);
	if (config.getCheckTextoSecundario()){
	   	labelTextoSecundario = new QLabel(this);
	   	labelTextoSecundario->setFont( fonte );
		labelTextoSecundario->setAlignment(Qt::AlignCenter);
	   	labelTextoSecundario->setText(config.getTextoSecundario());
		caixaTextoSecundario = new QTextBrowser(this);
		caixaTextoSecundario->setText(carregarTexto(strLivroCapitulo, idTestamento, strPassagem, TEXTO_SECUNDARIO));
		fonte = QFont("Bitstream", config.getPointSizeTexto("BIBLIA"));
		caixaTextoSecundario->setFont( fonte );
		fonte = QFont("Bitstream", FONTE_MEDIA);
		caixaTextoSecundario->setReadOnly(true);
	}

	QObject::connect(aumentarFonte,SIGNAL(triggered() ),this, SLOT(slotZoomIn() ) );
	QObject::connect(diminuirFonte,SIGNAL(triggered() ),this, SLOT(slotZoomOut() ) );
	QObject::connect(actFontePadrao,SIGNAL(triggered() ),this, SLOT(slotZoomDefault() ) );
}

QString ReadPassagens::carregarTexto(const QString &strLivroCapitulo, short int idTestamento, const QString &strPassagens, bool secundario){
	Ferramentas ferramentas;
	return strPassagens + ferramentas.passagens(strLivroCapitulo, idTestamento, secundario);
}

QString ReadPassagens::getLivroCapitulo(){
	return _strLivroCapitulo;
}
int ReadPassagens::getIdTestamento(){
	return _idTestamento;
}
QString ReadPassagens::getPassagem(){
	return _strPassagem;
}

ReadPassagens::~ReadPassagens(){
	close();
}

