/******************************************************************************
CLASSE READPESQUISA
CRIADO: 23-10-2008
ALTERADO: 23-10-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "readpesquisa.h"
#include "ferramentas.h"

ReadPesquisa::ReadPesquisa(const QString &strPesquisa, short int idTestamento, short int idModo):ReadBiblico(){
	unsigned short int FONTE_MEDIA = resolucao.getFonteMedia();
	_strPesquisa = strPesquisa;
	_idTestamento = idTestamento;
	_idModo = idModo;

	// Tamanho, Ttulo e cone
	setMinimumSize( QSize( 600, 500 ) ); resize(600, 500);
	
	//Carrega as variveis strLivro e strCapitulo
	prepareLivroCapitulo(strPesquisa);
	
	//Seta o ttulo da Janela
	setWindowTitle("\"" + strPesquisa + "\"");
	
	//Seta a fonte
	fonte = QFont("Bitstream", FONTE_MEDIA);

	//Caixa de texto
	labelTexto->setText(config.getTextoPrincipal());
	caixaTexto->setText(carregarTexto(strPesquisa, idTestamento, TEXTO_PRIMARIO));
	fonte = QFont("Bitstream", config.getPointSizeTexto("BIBLIA"));
	caixaTexto->setFont( fonte );
	fonte = QFont("Bitstream", FONTE_MEDIA);
	caixaTexto->setReadOnly(TRUE);

	//Caixa de texto Auxiliar
	fonte = QFont("Bitstream", FONTE_MEDIA);
	if (config.getCheckTextoSecundario()){
	   	labelTextoSecundario = new QLabel(this);
	   	labelTextoSecundario->setFont( fonte );
		labelTextoSecundario->setAlignment(Qt::AlignCenter);
	   	labelTextoSecundario->setText(config.getTextoSecundario());
		caixaTextoSecundario = new QTextBrowser(this);
		caixaTextoSecundario->setText(carregarTexto(strPesquisa, idTestamento, TEXTO_SECUNDARIO));
		fonte = QFont("Bitstream", config.getPointSizeTexto("BIBLIA"));
		caixaTextoSecundario->setFont( fonte );
		fonte = QFont("Bitstream", FONTE_MEDIA);
		caixaTextoSecundario->setReadOnly(true);
	}

	QObject::connect(aumentarFonte,SIGNAL(triggered() ),this, SLOT(slotZoomIn() ) );
	QObject::connect(diminuirFonte,SIGNAL(triggered() ),this, SLOT(slotZoomOut() ) );
	QObject::connect(actFontePadrao,SIGNAL(triggered() ),this, SLOT(slotZoomDefault() ) );
	
}

QString ReadPesquisa::carregarTexto(const QString &strPesquisa, short int idTestamento, bool secundario){
	Ferramentas ferramentas;
	return ferramentas.busca(strPesquisa, idTestamento, _idModo, secundario);
}

QString ReadPesquisa::getPesquisa(){
	return _strPesquisa;
}
int ReadPesquisa::getIdTestamento(){
	return _idTestamento;
}
int ReadPesquisa::getIdModo(){
	return _idModo;
}

ReadPesquisa::~ReadPesquisa(){
	close();
}

